
suppressMessages(library(rioja))

args <- commandArgs(trailingOnly=TRUE)

file_Z = args[1]
file_out = args[2]

dat <- read.table(file_Z)

diss <- dist(dat)
clust <- chclust(diss)

bs <- bstick(clust, nrow(dat)-1, plot=FALSE)
r <- rle(bs$dispersion > bs$bstick)

min_cluster <- 2
max_cluster <- r$lengths[r$values][1]
#min_cluster <- min(min_cluster, max_cluster)
#min_cluster = as.integer(nrow(dat)/30)
#max_cluster = as.integer(nrow(dat)/10)

if (is.na(max_cluster) || max_cluster <= min_cluster) {
	max_cluster = min_cluster
}

chcs <- NULL
for (n in min_cluster:max_cluster) {
  chc <- cutree(clust, k = n)
	chcs <- cbind(chcs, chc)
}

#print(max_broken)
#print(max_cluster)

write.table(chcs, file=file_out, row.names=F, col.names=F, sep=" ", quote=F)



