#!/usr/bin/env perl
use warnings;
use strict;

my $f_coordinates = $ARGV[0];
my $f_output = $ARGV[1];

my @coords;
open IN, "$f_coordinates" or die $!;
while (my $line = <IN>) {
	chomp $line; 
  	$line =~ s/^\s+//; 
  	$line =~ s/\s+$//;
  	my @items = split(/\s+/, $line);
  	push(@coords, \@items);
}
close IN;

my $num_points = @coords;

my @chains = ('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');

my $pdb_id = 0;
open OUT, ">$f_output";
for (my $i = 0; $i < $num_points; $i++) {
	my $chr = $coords[$i][0];
 	my $chain_id;
	if ($chr ne 'X'){
		$chain_id = $chains[$chr-1];
	} else {
		$chain_id = 'Z'; # chrX's chain id is 'Z'
	}
	$pdb_id++;
    	print_pdb_atom($coords[$i][2], $coords[$i][3], $coords[$i][4], $pdb_id, $chain_id, $coords[$i][1]);
}
close OUT;

sub print_pdb_atom {
  	my $x = $_[0];
	my $y = $_[1];
  	my $z = $_[2];
  	my $curr_index = $_[3];
	my $chain_id = $_[4];
	my $col = $_[5];


  	$x = sprintf "%0.3f", $x;
  	$y = sprintf "%0.3f", $y;
  	$z = sprintf "%0.3f", $z;
  	
	printf OUT "ATOM";
  	printf OUT "%7s", $curr_index;
  	printf OUT "  ";
  	printf OUT "%-3s", "CA";
  	printf OUT "%4s", "LIG";
	printf OUT "%2s", "$chain_id";
  	printf OUT "%4s", $col;

  	printf OUT "%12s", $x;
  	printf OUT "%8s", $y;
  	printf OUT "%8s", $z;
  	printf OUT "%6s", "1.00";
  	printf OUT "%6s", "70";
  	printf OUT "\n";
}


